#!/usr/bin/perl -w

use strict;
use Socket;
use Getopt::Std;
use vars qw($VERSION $opt_v $opt_h $opt_i $opt_p $opt_f $opt_d $opt_t $opt_a);
$VERSION = '0.1';

getopts("hvp:i:f:d:t:a:");

my $DEFAULT_IP      = '192.168.1.1';
my $DEFAULT_PORT    = 137;
my ($winsdata,$winstype,$winsaddr);

if ($opt_h) { usage(); exit(0); }
if ($opt_v) { print "winsreg version $VERSION\n"; exit(0); }
if (!$opt_a or !$opt_t or !$opt_d) { usage(); exit(0); }
#if (!$opt_f and !@ARGV) { usage(); exit(0); }
if ($opt_i) { $DEFAULT_IP = $opt_i; }		# override default
if ($opt_p) { $DEFAULT_PORT = $opt_p; }		# override default
if ($opt_f) { process_file($opt_f); }

register($opt_d,$opt_t,$opt_a);

sub register
{
	my $winsdata=shift;
	my $winstype=shift;
	my $winsaddr=shift;
	my $i=0;
	my @data=(0x43,0x41,0x43,0x41,0x43,0x41,0x43,0x41,
		0x43,0x41,0x43,0x41,0x43,0x41,0x43,0x41,
		0x43,0x41,0x43,0x41,0x43,0x41,0x43,0x41,
		0x43,0x41,0x43,0x41,0x43,0x41,0x43,0x41);
	foreach ( split('',$winsdata) ) {
		my ($h1,$h2) = split('',sprintf("%X",ord(uc($_))));
		if ( ! defined($h2) ) { $h2=$h1; $h1="0" }
		$data[$i]= eval("0x".$h1) + 0x41;
		$data[$i+1]= eval("0x".$h2) + 0x41;
		$i+=2;
	}
	my ($wt1,$wt2)=split('',$winstype);
	$data[30]= eval("0x".$wt1) + 0x41;
	$data[31]= eval("0x".$wt2) + 0x41;
	my @ip=split('\.',$winsaddr);
	my ($raddr, $them, $laddr, $us, $proto);
	my ($hwaddr_re, $pkt);
	
	# Alocate socket and send packet

	$raddr = gethostbyname($DEFAULT_IP);
	$laddr = gethostbyname('130.144.96.14');
	$them = pack_sockaddr_in($DEFAULT_PORT, $raddr);
	$us   = pack_sockaddr_in($DEFAULT_PORT, $laddr);
	$proto = getprotobyname('udp');

	socket(S, AF_INET, SOCK_DGRAM, $proto) or die "socket : $!";
	my $msg = pack("C68",0x80,0x10, 0x29,
		0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x20,
		@data,
		0x00, 0x00, 0x20, 0x00, 0x01, 0xc0, 0x0c, 0x00, 0x20,
		0x00, 0x01, 0x00, 0x04, 0x93, 0xe0, 0x00, 0x06, 0x60,
		0x00, @ip
 );
	my $len_msg = length($msg);
	my $num_short = $len_msg / 2;

	#print "Sending WINS REG packet to $DEFAULT_IP:$DEFAULT_PORT\n";

	bind(S, $us);
	send(S, $msg, 0, $them) or die "send : $!";
	my $res='';
	recv(S,$res,0,0);
	close S;
}

sub process_file {
	my $filename = shift;

	open (F, "<$filename") or die "open : $!";
	while(<F>) {
		next if /^\s*#/;		# ignore comments
		next if /^\s*$/;		# ignore empty lines

		chomp;
		my ($data, $type, $addr) = split;

		register($data, $type, $addr);
	}
	close F;
}


#
# Usage
#

sub usage {
print <<__USAGE__;
NAME
    winsreg.pl - register NETBIOS names in WINS

SYNOPSYS
    winsreg.pl [-h] [-v] [-i IP_addr] [-p port] [-d name] [-t type] [-a IP_addr] [-f file]

OPTIONS
    -h
        this information
    -v
        displays the script version
    -i ip_addr
        set the destination IP address of WINS server
        default: 130.144.100.75
    -p port
        set the destination port
        default: 137 (netbios-ns port)
    -d name
        set the value of the WINS record (hostname/username)
    -t type
        set the WINS record type :
	00      WORKSTATION
        03      MESSENGER
        1E      BROWSER ELECTION
        43      SMS CLIENT
        20      SERVER
        1B      DOMAIN MASTER BROWSER
        1C      DOMAIN CONTROLLER
    -a ip_addr
        set the IP address of the WINS record

    -f file
        read entries to process from file

EXAMPLES
    Register NETBIOS name NTSERVER with address 192.168.1.1 as server :
    winsreg.pl -d NTSERVER -t 20 -a 192.168.1.1

    Read file with entries and send updates to WINS-server 192.168.1.1 port 37
    winsreg.pl -i 192.168.1.1 -p 37 -f inputfile

AUTHOR
    Frank van Gestel (frank.van.gestel\@sysman.nl)

SEE ALSO
    Microsoft Knowledgebase Article #325324 : How to spoof WINS

__USAGE__
}


__END__
